Imports System.Threading
'NOTE: This example application shows how to use the EX_ prefixed DLL functions to initialized, scan, and other I/O 
'EX_  prefixed function calls documented within the webpage that the link below will take you to:
'       http://www.lawsonlabs.com/Download/Manuals-Drivers/Model_301_302/M30x_SP_X/Shared/ArchiveContents/_HTML_docs/FunctionUsage/FuncUse.htm
'  the same link condensed for easy copy:
'       http://tinyurl.com/62qp6a
'Using CTRL + "left mouse button" will load the page here for you.
'Links from the main page: http://www.lawsonlabs.com to the developer's section will provide additional
'  links for other software language examples, answers to some frequently asked questions, links to prototypes
'  and related information for the older API's, as well as other reference material.
'This example uses default configuration. There are many configuration options, but they are not shown here 
'in an attempt to keep the code simple.

Public Class Form1
    Public scanChanVolts(8), scanChanDig(8) As TextBox, scanChanLabels(8) As Label
    Public fSignedOn, fScanRunning, fRetValMisc, fScanPause As Boolean
    Public usCurDevID As Short, lRawCountArray() As Integer
    Public bDiginBuff() As Byte

    Public Const SINGLE_CHAN_SCAN As Short = 1 : Public Const MULTI_CHAN_SCAN As Short = 2
    Public Const MULTI_CHAN_CAL_SCAN As Short = 3 : Public Const SINGLE_CHAN_DIGIN_SCAN As Short = 4
    Public Const MULTI_CHAN_DIGIN_SCAN As Short = 5 : Public Const MULTI_CHAN_CAL_DIGIN_SCAN As Short = 6
    Public Const SCAN_USE_DATA_LOG_FILE As Short = 1 : Public Const SCAN_USE_DATA_ARRAY As Short = 2
    Public Const SCAN_STOP_ON_DATA_ARRAY_WRAP As Short = 2 : Public Const SCAN_LIMIT_LOG_FILE_SIZE As Short = 8

    Declare Function EX_ConnectAllDevices Lib "LL_USB2k.DLL"  (ByRef bDevCnt As Byte, ByRef pusDevList As Short, ByRef dblRate As Double) As Byte
    'alternate (12.9.08 or later DLL required) 
    Declare Function EX_ConnectOneDevice Lib "LL_USB2k.DLL" (ByVal usDevID As Short, ByVal dblRate As Double, ByVal bChan As Byte) As Byte

    Declare Function EX_SetMultiChanScanChans Lib "LL_USB2k.DLL" (ByVal usDeviceID As Short, ByVal bChanCnt As Byte) As Byte
    Declare Function EX_SetDataLogOptions Lib "LL_USB2k.DLL" (ByVal usDeviceID As Short, ByVal uiDataLogMethod As Integer,  ByVal uiLogFileMaxSize As Integer, ByVal uiMisc As Integer) As Byte
    Declare Function EX_SetScanType Lib "LL_USB2k.DLL" (ByVal usDeviceID As Short, ByVal bScanType As Byte) As Byte
    Declare Function EX_Run Lib "LL_USB2k.DLL" (ByVal usDeviceID As Short) As Byte
    Declare Function EX_CheckScanStatus Lib "LL_USB2k.DLL" (ByVal usDeviceID As Short, ByRef puiNumScansRemainingInBuff As Integer,  ByRef pfStillScanning As Byte, ByRef puiStatusCode As Integer) As Byte
    Declare Function EX_GetScanDataIntDigin Lib "LL_USB2k.DLL" (ByVal usDeviceID As Short,  ByRef piDataBuff As Integer, ByRef pbDiginBuff As Byte, ByVal uiNumScansToReturn As Integer,  ByVal fGetAllRequested As Byte, ByRef puiNumScansReturned As Integer, ByRef puiNumScansRemainingInBuff As Integer,  ByRef pfStillScanning As Byte, ByRef puiTotalBuffSize As Integer, ByRef puiErrCode As Integer) As Byte
    Declare Function EX_Stop Lib "LL_USB2k.DLL" (ByVal usDeviceID As Short) As Byte
    Declare Function EX_StopComplete Lib "LL_USB2k.DLL" (ByVal usDeviceID As Short) As Byte

    Declare Function EX_SendDigout Lib "LL_USB2k.dll" (ByVal usDevID As Short, ByVal bDigOut As Byte) As Byte
    Declare Function EX_GetDigin Lib "LL_USB2k.dll" (ByVal usDevID As Short, ByRef bDigOut As Byte) As Byte
    Declare Function EX_SendChan Lib "LL_USB2k.DLL" (ByVal usDeviceID As Short, ByVal bCurChan As Byte, ByRef pbDigInput As Byte) As Byte
    Declare Function EX_SendRate Lib "LL_USB2k.DLL" (ByVal usDeviceID As Short, ByRef dblRate As Double) As Byte

    Private Sub btnConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConnect.Click
        btnConnect.Enabled = False : btnStartScan.Enabled = False : btnExit.Enabled = False
        usCurDevID = txtDevID.Text
        Dim dblRate(32) As Double : dblRate(0) = comboRate.Text
        Dim pusDevList(32) As Short : pusDevList(0) = usCurDevID
        Dim bRetVal, bDevCnt As Byte : bDevCnt = 1

        Msgs.Text = "Initializing at " & dblRate(0) & "Hz.  -> wait. . . " & vbCrLf : System.Windows.Forms.Application.DoEvents()
        bRetVal = EX_ConnectAllDevices(bDevCnt, pusDevList(0), dblRate(0))
        'bRetVal = EX_ConnectOneDevice(usCurDevID, dblRate(0), 0)

        If (bRetVal = 0) Or (pusDevList(0) = 0) Then
            Msgs.Text = Msgs.Text & "EX_ConnectAllDevices() failed" & vbCrLf : System.Windows.Forms.Application.DoEvents()
            btnConnect.Enabled = True : btnExit.Enabled = True : btnDigOut.Enabled = False : btnDigIn.Enabled = False : Exit Sub
        End If
        Msgs.Text = Msgs.Text & "EX_ConnectAllDevices() success" & vbCrLf : System.Windows.Forms.Application.DoEvents()
        fSignedOn = True : btnStartScan.Focus() : System.Windows.Forms.Application.DoEvents()
        btnStartScan.Enabled = True : btnStopScan.Enabled = False : lblMainChan.Enabled = True
        comboMainChan.Enabled = True : comboScanChans.Enabled = True : lblScanChans.Enabled = True : chkCalScan.Enabled = True
        btnDigOut.Enabled = True : btnDigIn.Enabled = True
        Msgs.Text = Msgs.Text & "Successful initialization" & vbCrLf : System.Windows.Forms.Application.DoEvents()
        btnConnect.Enabled = True : btnStartScan.Enabled = True : btnExit.Enabled = True
    End Sub
    Private Sub btnStartScan_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStartScan.Click
        Dim numTotalChans, bRetVal, bCurScanChan, bModVal As Byte
        Dim mscIndex, numPointsToRead, numPointsPerScan, iCalScanChanOffset, uiScanType As Integer
        Dim avgVal, dblCalVal, dVoltageSingConv As Double

        btnStartScan.Enabled = False : btnDigIn.Enabled = False : btnPause.Enabled = True : comboRate.Enabled = False : lblRate.Enabled = False : comboScanChans.Enabled = False : lblScanChans.Enabled = False : lblScanChans.Enabled = False : chkCalScan.Enabled = False : btnExit.Enabled = False : btnConnect.Enabled = False : btnStopScan.Enabled = True : btnStopScan.Focus() : System.Windows.Forms.Application.DoEvents()

        numTotalChans = (comboScanChans.Text + chkCalScan.CheckState)
        If numTotalChans > 8 Then numTotalChans = 8
        uiScanType = SINGLE_CHAN_DIGIN_SCAN
        If comboScanChans.Text > 1 Then uiScanType = MULTI_CHAN_DIGIN_SCAN
        If chkCalScan.Checked Then : uiScanType = MULTI_CHAN_CAL_DIGIN_SCAN
        Else
            For mscIndex = 0 To comboScanChans.Items.Count - 1 : scanChanVolts(mscIndex).Text = "" : scanChanDig(mscIndex).Text = "" : Next mscIndex
            For mscIndex = 0 To comboScanChans.Items.Count - 1 : scanChanVolts(mscIndex).Enabled = False : scanChanDig(mscIndex).Enabled = False : scanChanLabels(mscIndex).Enabled = False : Next mscIndex
            For mscIndex = 0 To numTotalChans - 1 : scanChanVolts(mscIndex).Enabled = True : scanChanDig(mscIndex).Enabled = True : scanChanLabels(mscIndex).Enabled = True : Next mscIndex
        End If
        If chkCalScan.Checked Then : scanChanVolts(7).Enabled = True : scanChanDig(7).Enabled = True : End If

        EX_SetMultiChanScanChans(usCurDevID, numTotalChans)
        EX_SetDataLogOptions(usCurDevID, SCAN_USE_DATA_ARRAY, 0, 0)
        EX_SetScanType(usCurDevID, uiScanType)

        Dim puiNumScansRemainingInBuff, puiNumScansReturned, puiStatusCode, puiErrCode As Integer
        Dim pfStillScanning As Byte
        bRetVal = EX_Run(usCurDevID)
        If bRetVal Then
            Msgs.Text = Msgs.Text & "success starting scan" & vbCrLf
            'btnStartScan.Enabled = False : btnPause.Enabled = True : comboRate.Enabled = False : lblRate.Enabled = False : comboScanChans.Enabled = False : lblScanChans.Enabled = False : lblScanChans.Enabled = False : chkCalScan.Enabled = False : btnExit.Enabled = False : btnConnect.Enabled = False : btnStopScan.Enabled = True : btnStopScan.Focus() : System.Windows.Forms.Application.DoEvents()
            bCurScanChan = 0 : bModVal = comboScanChans.Text : fScanPause = False : btnPause.Text = "pause data read"
            If (chkCalScan.Checked) And (comboScanChans.Text > 1) And (comboScanChans.Text < 8) Then bModVal += 1
            numPointsPerScan = numTotalChans
            fScanRunning = True

            'this array has to be sized according to the number of points it's going to hold
            ReDim lRawCountArray(numPointsPerScan), bDiginBuff(numPointsPerScan)
            dblCalVal = 0.0 : Dim bval As Long
            Dim numScans As Integer : numScans = 0
            While fScanRunning = True
                'lblScanChans.Enabled = False
                System.Windows.Forms.Application.DoEvents()
                bRetVal = EX_CheckScanStatus(usCurDevID, puiNumScansRemainingInBuff, pfStillScanning, puiStatusCode)
                If pfStillScanning = 0 Then
                    fScanRunning = False : Continue While
                End If
                txtBuffPoints.Text = puiNumScansRemainingInBuff : txtBuffPoints.Update()
                If puiNumScansRemainingInBuff < 1 Then Continue While
                If fScanPause Then : bval = 0 : Continue While : End If
                numPointsToRead = puiNumScansRemainingInBuff * numTotalChans
                ReDim lRawCountArray(numPointsToRead), bDiginBuff(numPointsToRead)
                'the code below does limited work to keep this example small. It is recommended that the various
                ' parameters passed in the call be used - for example puiErrCode.
                bRetVal = EX_GetScanDataIntDigin(usCurDevID, lRawCountArray(0), bDiginBuff(0), puiNumScansRemainingInBuff, 0, puiNumScansReturned, puiNumScansRemainingInBuff, pfStillScanning, puiNumScansRemainingInBuff, puiErrCode)
                If bRetVal Then
                    iCalScanChanOffset = numPointsPerScan - 1
                    For mscIndex = 0 To numPointsToRead - 1
                        System.Windows.Forms.Application.DoEvents()
                        If chkCalScan.Checked Then
                            If mscIndex Then : If (mscIndex Mod numPointsPerScan) = 0 Then iCalScanChanOffset += numPointsPerScan
                            End If
                            'Msgs.Text = iCalScanChanOffset & ", " & numPointsPerScan : Msgs.Update()
                            dblCalVal = ((lRawCountArray(iCalScanChanOffset) - 8388608) * 0.00000059604645)
                            scanChanVolts(7).Text = Format(dblCalVal, "#####.000000")
                        End If : avgVal = 0

                        'if cal-scan then the voltage from the calibration channel (7) will be subtracted from
                        ' each channel, otherwise nothing is subtracted since dblCalVal is set to 0 at top.
                        dVoltageSingConv = ((lRawCountArray(mscIndex) - 8388608) * 0.00000059604645) - dblCalVal

                        'NOTE: the MODding of the data used various places below is only used to make it easier to 
                        'organize the data coming out of the array for multiple channels, into the correct display boxes.
                        If comboScanChans.Text = 1 Then
                            scanChanVolts(mscIndex Mod bModVal).Text = Format(dVoltageSingConv, "#####.000000")
                            scanChanDig(mscIndex Mod bModVal).Text = bDiginBuff(mscIndex)
                            Continue For
                        End If

                        If mscIndex Then
                            'for display and test purpose only!
                            'if more one scan is to be displayed, then have a small delay between displaying
                            ' each scan, just so we can see that the data is not scrambled when multiple
                            ' scans are read from the buffer. txtWaitLoops just shows how many times we did this
                            If ((mscIndex Mod numTotalChans) = 1) And (mscIndex > (numTotalChans * 2)) Then
                                'Dim waitTime As New TimeSpan(0, 0, 0, 0, 50): Thread.Sleep(waitTime)
                                Thread.Sleep(Int(20000 / Int(comboRate.Text)))
                                bval += 1 : txtWaitLoops.Text = bval
                            End If
                        End If

                        'the following just prevents showing the data from cal scan in the wrong box
                        If (CByte(mscIndex \ bModVal) = 1) And CByte(chkCalScan.CheckState) Then Continue For

                        'if here, then it's multi-channel scan so make sure all data gets into the correct box
                        scanChanVolts(mscIndex Mod bModVal).Text = Format(dVoltageSingConv, "#####.000000")
                        scanChanDig(mscIndex Mod bModVal).Text = bDiginBuff(mscIndex) : txtDigIn.Text = bDiginBuff(mscIndex)
                        scanChanVolts(mscIndex Mod bModVal).Update()
                        scanChanDig(mscIndex Mod bModVal).Update()
                        If Not fScanRunning Then Exit For
                    Next mscIndex
                End If
            End While
            'both of the following are required due to the threading of the scan process within the DLL
            bRetVal = EX_Stop(usCurDevID) : bRetVal = EX_StopComplete(usCurDevID)
            Msgs.Text = "scan stopped" & vbCrLf : btnStartScan.Enabled = True : chkCalScan.Enabled = True
            comboRate.Enabled = True : btnDigIn.Enabled = True : lblRate.Enabled = True : comboScanChans.Enabled = True : lblScanChans.Enabled = True : btnConnect.Enabled = True : btnExit.Enabled = True : btnStopScan.Enabled = False : btnStartScan.Focus() : System.Windows.Forms.Application.DoEvents()
        Else
            Msgs.Text = Msgs.Text & "failed to start scan" & vbCrLf : fScanRunning = False
        End If
        Msgs.Text = Msgs.Text & "exiting scanning" & vbCrLf : btnPause.Enabled = False
        btnDigIn.Enabled = True
    End Sub
    'Private Sub btnScan_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStartScan.Click
    'End Sub
    Private Sub btnScanStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        If fScanRunning = True Then
            Msgs.Text = "Stopping scan - please wait...." & vbCrLf
            btnStopScan.Enabled = False
            System.Windows.Forms.Application.DoEvents()
            fScanRunning = False
        End If
    End Sub
    Private Sub btnStopScan_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        If fScanRunning = True Then
            Msgs.Text = "Stopping scan - please wait...." & vbCrLf
            btnStopScan.Enabled = False
            System.Windows.Forms.Application.DoEvents()
            fScanRunning = False
        End If
    End Sub
    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles comboMainChan.SelectedIndexChanged
        Dim bRetVal, bCurDigin As Byte
        bRetVal = EX_SendChan(usCurDevID, comboMainChan.Text, bCurDigin)
    End Sub
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        fSignedOn = False : fScanRunning = False
        scanChanVolts(0) = txtVolts0 : scanChanVolts(1) = txtVolts1 : scanChanVolts(2) = txtVolts2 : scanChanVolts(3) = txtVolts3 : scanChanVolts(4) = txtVolts4 : scanChanVolts(5) = txtVolts5 : scanChanVolts(6) = txtVolts6 : scanChanVolts(7) = txtVolts7
        scanChanDig(0) = txtDig0 : scanChanDig(1) = txtDig1 : scanChanDig(2) = txtDig2 : scanChanDig(3) = txtDig3 : scanChanDig(4) = txtDig4 : scanChanDig(5) = txtDig5 : scanChanDig(6) = txtDig6 : scanChanDig(7) = txtDig7
        scanChanLabels(0) = lblChan0 : scanChanLabels(1) = lblChan1 : scanChanLabels(2) = lblChan2 : scanChanLabels(3) = lblChan3 : scanChanLabels(4) = lblChan4 : scanChanLabels(5) = lblChan5 : scanChanLabels(6) = lblChan6 : scanChanLabels(7) = lblChan7
        lblScanChans.Enabled = False
        usCurDevID = 0 : fScanPause = False
    End Sub
    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        If fScanRunning = True Then
            Msgs.Text = Msgs.Text & "stopping scan - WAIT" & vbCrLf : System.Windows.Forms.Application.DoEvents()
            While fScanRunning = True : System.Windows.Forms.Application.DoEvents() : End While
        End If
        fScanRunning = False : Form1.ActiveForm.Close()
    End Sub
    Private Sub comboScanChans_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles comboScanChans.SelectedIndexChanged
        Dim mscIndex As Byte
        For mscIndex = comboScanChans.Text To comboScanChans.Items.Count - 1 : scanChanVolts(mscIndex).Text = "" : scanChanDig(mscIndex).Text = "" : Next mscIndex
        For mscIndex = 0 To comboScanChans.Items.Count - 1 : scanChanVolts(mscIndex).Enabled = False : scanChanDig(mscIndex).Enabled = False : scanChanLabels(mscIndex).Enabled = False : Next mscIndex
        For mscIndex = 0 To comboScanChans.Text - 1 : scanChanVolts(mscIndex).Enabled = True : scanChanDig(mscIndex).Enabled = True : scanChanLabels(mscIndex).Enabled = True : Next mscIndex
        If chkCalScan.Checked Then : scanChanVolts(7).Text = "" : scanChanDig(7).Text = "" : scanChanVolts(7).Enabled = True : scanChanDig(7).Enabled = True : scanChanLabels(7).Enabled = True
        Else : scanChanVolts(7).Enabled = False : scanChanDig(7).Enabled = False : scanChanLabels(7).Enabled = False : End If
    End Sub
    Private Sub comboRate_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles comboRate.SelectedIndexChanged
        If fSignedOn Then
            PanelWait.Location = New Point(12, 100)
            Msgs.Text = "Sending rate - wait. . ." & vbCrLf : System.Windows.Forms.Application.DoEvents()
            EX_SendRate(usCurDevID, CDbl(comboRate.Text))
            PanelWait.Location = New Point(16, 286)
            Msgs.Text = Msgs.Text & "Rate sent" & vbCrLf : System.Windows.Forms.Application.DoEvents()
        End If
    End Sub
    Private Sub chkCalScan_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkCalScan.CheckStateChanged
        Dim mscIndex As Byte
        For mscIndex = 0 To comboScanChans.Items.Count - 1 : scanChanVolts(mscIndex).Enabled = False : scanChanDig(mscIndex).Enabled = False : scanChanLabels(mscIndex).Enabled = False : Next mscIndex
        For mscIndex = 0 To comboScanChans.Text - 1 : scanChanVolts(mscIndex).Enabled = True : scanChanDig(mscIndex).Enabled = True : scanChanLabels(mscIndex).Enabled = True : Next mscIndex
        For mscIndex = 0 To comboScanChans.Text - 1 : scanChanVolts(mscIndex).Text = "" : scanChanDig(mscIndex).Text = "" : Next mscIndex
        If chkCalScan.Checked Then : scanChanVolts(7).Text = "" : scanChanVolts(7).Enabled = True : scanChanDig(7).Enabled = True : scanChanLabels(7).Enabled = True
        Else : scanChanVolts(7).Enabled = False : scanChanDig(7).Enabled = False : scanChanLabels(7).Enabled = False : End If
    End Sub
    Private Sub btnPause_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPause.Click
        If fScanPause Then
            btnPause.BackColor = System.Drawing.Color.FromName("Control")
            fScanPause = False : btnPause.Text = "pause scan read"
        Else
            btnPause.BackColor = System.Drawing.Color.FromArgb(255, 200, 200)
            fScanPause = True : btnPause.Text = "data read paused"
        End If
    End Sub
    Private Sub chkCalScan_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkCalScan.CheckedChanged
        'MsgBox(chkCalScan.CheckState)
    End Sub
    Private Sub btnStopScan_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStopScan.Click
        If fScanRunning = True Then
            Msgs.Text = "Stopping scan - please wait...." & vbCrLf
            btnStopScan.Enabled = False
            System.Windows.Forms.Application.DoEvents()
            fScanRunning = False
        End If
    End Sub
    Private Sub btnDigOut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDigOut.Click
        EX_SendDigout(usCurDevID, CByte(txtDigout.Text))
    End Sub
    Private Sub btnDigIn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDigIn.Click
        Dim bDigin As Byte
        EX_GetDigin(usCurDevID, bDigin)
        txtDigIn.Text = bDigin
    End Sub
End Class

' more prototypes and other information for new DLL:
'   http://www.lawsonlabs.com/Download/Manuals-Drivers/Model_301_302/Docs/30xmain.php?model=301



